<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Normal.php 2024 2005-03-10 17:21:43Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/max/Maintenance/Priority/AdServer/RequiredAdvertisementImpression/Common.php';

/**
 * The default implementation of {@link Maintenance_Priority_AdServer_RequiredAdvertisementImpression_Common}
 * distributed with Max.
 */
class Maintenance_Priority_AdServer_RequiredAdvertisementImpression_Normal extends Maintenance_Priority_AdServer_RequiredAdvertisementImpression_Common
{
    
    /**
     * The default implementation of 
     * {@link Maintenance_Priority_AdServer_RequiredAdvertisementImpression_Common::calculateRequiredImpressions()}
     * distributed with Max.
     *
     * For each active, non-house campaign advertisement, this method calculates the
     * number of required impressions in the next operation interval.
     *
     * For advertisements in campaigns with Inventory Requirements and a Campaign Expiration
     * Date, the required impressions are calculated using the following algorithm:
     *
     * - If the advertisement is in a campaign that has Click or Connection/Conversion
     *   Inventory Requirements, then convert these into Impression Inventory Requirements
     *   on the basis of the advertisement's Click Through Ratio or Connection/Conversion
     *   Ratio. 
     * - Using the smallest of the real or calculated Impression Inventory Requirement values,
     *   distribute the required impressions between the campaign's advertisements, on the 
     *   basis of the campaign's advertisement's weights.
     * - For each advertisement, divide the number of impressions allocated equally between
     *   the available operation intervals remaining in the day(s) before the end of the
     *   campaign. Do not include any operation intervals where the advertisement has been
     *   blocked from delivering (ie. a Day, Time, or Date Delivery Limitation exists). The
     *   number of impressions for each remaining operation interval will be the number of
     *   impressions required for the next operation interval, unless the advertisement is
     *   blocked from delivering in the next operation interval.
     *
     * For advertisements in campaigns with a Manual Daily Limit, the required impressions
     * are calculated using the following algorithm:
     *
     * - If the advertisement is in a campaign that has a Manual Daily Click or Manual Daily
     *   Connection/Conversion Limit, then convert these into Maunal Daily Impression Limits
     *   on the basis of the advertisement's Click Through Ratio or Connection/Conversion 
     *   Ratio.
     * - Using the smallest of the real or calculated Manual Daily Impression Limit values,
     *   distribute the required impressions between the campaign's advertisements, on the 
     *   basis of the campaign's advertisement's weights.
     * - For each advertisement, divide the number of impressions allocated equally between
     *   the available operation intervals remaining in the day. Do not include any operation
     *   intervals where the advertisement has been blocked from delivering (ie. a Day,
     *   Time, or Date Delivery Limitation exists). The number of impressions for each remaining
     *   operation interval will be the number of impressions required for the next operation
     *   interval, unless the advertisement is blocked from delivering in the next operation
     *   interval.
     *
     * All other advertisements have an infinite number of required impressions in the next
     * operation interval, unless the advertisement is blocked from delivering in the next
     * operation interval.
     *
     * @TODO Needs to be written.
     */
    function calculateRequiredImpressions()
    {
        
    }
    
}

?>
