<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Common.php 2024 2005-03-10 17:21:43Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * An abstract class used to specify the interface for classes that forecast the
 * expected number of impressions in each operation interval, for each zone.
 *
 * @abstract
 */
class Maintenance_Priority_AdServer_ZoneImpressionForecast_Common
{
    var $conf;
    var $now;
    var $report;
    var $updateAll;
    var $updateRange;
    
    /**
     * A common constructor method that can be used by each subclass of the interface.
     *
     * The constructor method determines when the last time  the Maintenance Priority
     * process last updated the forecast of expected impressions, and compares this
     * with the last time the Maintenance Statistics process last updated the
     * statistics. If necessary, the constructor sets the required operation intervals
     * that require that their zone impression forecasts be updated.
     *
     * @param Date $now Optional Date representing the current date/time.
     *                  Used for testing the constructor method.
     *
     * @TODO Needs to be written.
     */
    function Maintenance_Priority_AdServer_ZoneImpressionForecast_Common($now = null)
    {
        
    }
 
    /**
     * A method for updating the forecast of the expected number of impressions
     * for each operation interval, for each zone.
     */
    function forecastZoneImpressions() {}
    
}

?>
