<?php

    require_once(MAX_PATH . '/lib/max/Plugins/PluginTranslation.php');

    define('MAX_PLUGINTRANSLATION_TEST_DIR', dirname(__FILE__).'/testdir');

    class TestOfPluginTranslation extends UnitTestCase {
        
        function TestOfPluginTranslation() {
            $this->UnitTestCase('PluginTranslation test');
        }

        function testIncludePluginLanguageFile() {
            $module = 'nonExistingModule';
            $package = 'nonExistingPackage';
            $language = 'nonExistingLanguage';
            
            $ret = Max_PluginTranslation::includePluginLanguageFile($module, null, $language);
            $this->assertIdentical($ret, false);
            $this->assertIdentical($GLOBALS['_MAX']['PLUGIN_TRANSLATION'][$module], false);
            
            $ret = Max_PluginTranslation::includePluginLanguageFile($module, $package, $language);
            $this->assertIdentical($ret, false);
            $this->assertIdentical($GLOBALS['_MAX']['PLUGIN_TRANSLATION'][$module][$package], false);
            
            $translate = 'Some translation string';
            $ret = Max_PluginTranslation::translate($translate, $module, $package);
            // translation wasn't included so should return the same value
            $this->assertIdentical($ret, $translate);
            
            $path = MAX_PLUGINTRANSLATION_TEST_DIR . '/translation.php';
            include $path;
            $ret = Max_PluginTranslation::includePluginLanguageFile($module,null,null,$path);
            $this->assertIdentical($ret, true);
            $this->assertIdentical($GLOBALS['_MAX']['PLUGIN_TRANSLATION'][$module], $words);
            
            $ret = Max_PluginTranslation::translate('translate me', $module);
            $this->assertIdentical($ret, 'translated text');
        }

        /**
         * something is wrong with mock objects...
         */
        function _REPAIR_ME_testConfig() {
            Mock::generate('Max_Plugins');
            
            $module = 'moduleName';
            $package = 'packageName';
            $processSections = false;
            
            $mockPlugin = &new MockMax_Plugins($this);
            $mockPlugin->setReturnValue('getConfigByFileName', true);
            
            $mockPlugin->expectOnce('getConfigByFileName');
            
            $ret = $mockPlugin->getConfig($module, $package, null, $commonPackageConfig = true, $processSections);
            $this->assertIdentical($ret, true);
            $mockPlugin->tally();
        }
        
        /**
         * TODO: upgrade simpletest
         */
        function _REPAIR_ME_testGetPlugins() {
            Mock::generate('Max_Plugins');
            $mockPlugins = new MockMax_Plugins($this);
            $mockPlugins->setReturnValue('getPluginsFromFolder', true);

            $recursive = true;
            $mockPlugins->expectOnce('getPluginsFromFolder', array(MAX_PATH.'/plugins/moduleName/packageName', $recursive));
            $ret = $mockPlugins->getPlugins('moduleName', 'packageName', $recursive);
            $mockPlugins->tally();
        }

    }

?>