<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-remotehost.inc.php 2155 2005-03-15 18:11:36Z radek $
*/

require_once('lib-io.inc.php');

// Check for proxyserver
if ($conf['logging']['proxyLookup']) {
    $proxy = false;
    if (isset ($_SERVER['HTTP_VIA']) && $_SERVER['HTTP_VIA'] != '') {
        $proxy = true;
    }
    if (isset ($_SERVER['REMOTE_HOST'])) {
        if (is_int(strpos('proxy',   $_SERVER['REMOTE_HOST']))) {
            $proxy = true;
        }
        if (is_int(strpos('cache',   $_SERVER['REMOTE_HOST']))) {
            $proxy = true;
        }
        if (is_int(strpos('inktomi', $_SERVER['REMOTE_HOST']))) {
            $proxy = true;
        }
    }
    if ($proxy) {
        // Overwrite host address if a suitable header is found
        if (isset($_SERVER['HTTP_FORWARDED']) && 		$_SERVER['HTTP_FORWARDED'] != '') {
            $IP = $_SERVER['HTTP_FORWARDED'];
        }
        if (isset($_SERVER['HTTP_FORWARDED_FOR']) &&	$_SERVER['HTTP_FORWARDED_FOR'] != '') {
            $IP = $_SERVER['HTTP_FORWARDED_FOR'];
        }
        if (isset($_SERVER['HTTP_X_FORWARDED']) &&		$_SERVER['HTTP_X_FORWARDED'] != '') {
            $IP = $_SERVER['HTTP_X_FORWARDED'];
        }
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) &&	$_SERVER['HTTP_X_FORWARDED_FOR'] != '') {
            $IP = $_SERVER['HTTP_X_FORWARDED_FOR'];
        }
        if (isset($_SERVER['HTTP_CLIENT_IP']) &&		$_SERVER['HTTP_CLIENT_IP'] != '') {
            $IP = $_SERVER['HTTP_CLIENT_IP'];
        }
        // Get last item from list
        $IP = explode(',', $IP);
        $IP = trim($IP[count($IP) - 1]);
        if ($IP && $IP != 'unknown' && !phpAds_PrivateSubnet($IP)) {
            $_SERVER['REMOTE_ADDR'] = $IP;
            $_SERVER['REMOTE_HOST'] = '';
        }
    }
}

// Reverse lookup
if (!isset($_SERVER['REMOTE_HOST']) || $_SERVER['REMOTE_HOST'] == '') {
    if ($conf['logging']['reverseLookup']) {
        $_SERVER['REMOTE_HOST'] = @gethostbyaddr($_SERVER['REMOTE_ADDR']);
    } else {
        $_SERVER['REMOTE_HOST'] = $_SERVER['REMOTE_ADDR'];
    }
}

// Geotracking
$geoInfo = false;
require_once MAX_PATH . '/lib/max/Plugins/Plugins.php';
$geo = Max_Plugins::factoryPluginByModuleConfig('geotargeting');
if ($geo) {
    $geoInfo = $geo->getInfo();
}

// Translate an IP address into a 32 bit integer
function phpAds_ipAddrToInt($ip)
{
    if (!preg_match('/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/', trim($ip), $match)) {
        return 0;
    }
    return (intval($match[1]) << 24) | (intval($match[2]) << 16) | (intval($match[3]) << 8) | intval($match[4]);
}

// Match an IP address against a subnet
function phpAds_matchSubnet($ip, $net, $mask)
{
    if (!is_integer($ip)) {
        $ip = phpAds_ipAddrToInt($ip);
    }
    $net = phpAds_ipAddrToInt($net);
    if (!$ip || !$net) {
        return false;
    }
    if (is_integer($mask)) {
        // Netmask notation x.x.x.x/y used
        if ($mask > 32 || $mask <= 0) {
            return false;
        } else if ($mask == 32) {
            $mask = ~0;
        } else {
            $mask = ~((1 << (32 - $mask)) - 1);
        }
    } else if (!($mask = phpAds_ipAddrToInt($mask))) {
        return false;
    }
    return ($ip & $mask) == ($net & $mask) ? true : false;
}

function phpAds_PrivateSubnet($ip)
{
    $ip = phpAds_ipAddrToInt($ip);
    if (!$ip) {
        return false;
    }
    return (phpAds_matchSubnet($ip, '10.0.0.0', 8) || phpAds_matchSubnet($ip, '172.16.0.0', 12) ||
            phpAds_matchSubnet($ip, '192.168.0.0', 16) || phpAds_matchSubnet($ip, '127.0.0.0', 24));
}

?>